package Flux_sample_operators;

import reactor.core.publisher.Flux;

import java.time.Duration;

public class FluxConcatMergeZip {
    public static void main(String[] args) throws Exception{

        Flux<Integer> even = Flux.range(1,10).filter(n->n%2==0);
        even.log().subscribe();

        Flux<Integer> odd = Flux.range(1,10).filter(n->n%2!=0);
        odd.log().subscribe();

        //concat() factory method
        Flux.concat(odd,even).log().subscribe(System.out::println);

        //with time duration
        Flux.concat(odd.delayElements(Duration.ofSeconds(1)),even.delayElements(Duration.ofSeconds(1))).log().subscribe(System.out::println);
        //concatWith() instance method
        odd.concatWith(even).log().subscribe(System.out::println);

        //combineLatest()
        Flux.combineLatest(odd,even,(a,b)->a+b).log().subscribe();

        Flux.combineLatest(odd,even,(a,b)->a+"+"+b+"="+a+b).log().subscribe();

        //merge factory method
        Flux.merge(odd,even).log().subscribe();

        //with time duration
        Flux.merge(odd.delayElements(Duration.ofSeconds(1)),even.delayElements(Duration.ofSeconds(1))).log().subscribe();

        //mergeSequential()
        Flux.mergeSequential(odd.delayElements(Duration.ofSeconds(1)),even.delayElements(Duration.ofSeconds(1))).log().subscribe();

        //mergeOrdered() deprecated

        //merge instance method
        odd.mergeWith(even).log().subscribe(System.out::println);

        //Thread.sleep(10000);

        //zip factory
        Flux.zip(odd,even).log().subscribe();
        Flux.zip(odd,even).map(t->t.getT1()+t.getT2()).log().subscribe();

        Flux<Long> interval = Flux.interval(Duration.ofSeconds(1));

        Flux.zip(interval,odd,even).map(t->t.getT1()+":"+(t.getT2()+t.getT3())).log().subscribe();

        Flux.zip(interval,odd,even).map(t->t.getT1()+":"+(t.getT2()+"->"+t.getT3())).log().subscribe();

        Thread.sleep(10000);

    }
}
