package Flux_sample_operators;

import reactor.core.publisher.Flux;

public class FluxEmptyJustError {
    public static void main(String[] args) {

        //empty()
        Flux.empty().
                doOnEach(sample-> System.out.println(sample.getType())).
                defaultIfEmpty("This is Empty default message").
                doOnNext(System.out::println).log().subscribe();

        //never()
        Flux.never().
                doOnEach(sample-> System.out.println(sample.getType())).
                defaultIfEmpty("This is Never default message").
                doOnNext(System.out::println).log().subscribe();

        //just()
        Flux.just("This","is","John","Smith").
                log().subscribe(System.out::println);

        //error()
        Flux.just("This","is","John","Smith").
                concatWith(Flux.error(new RuntimeException("This is Exception"))).doOnError(throwable -> {
                    System.out.println("This is throwable error"+throwable);
                }).log().subscribe(System.out::println);

        //factory error()
        Flux.error(new Exception("This is direct Exception")).
                log().subscribe(System.out::println);
    }
}
