package Flux_sample_operators;

import reactor.core.publisher.Flux;

public class FluxFilterMapAndFlatMap {

    public static void main(String[] args) {

        Flux<Integer> range = Flux.range(1,100);

        range.filter(n->n%2==0).subscribe(d->System.out.println("Sub1 Received : "+d),
                err->System.out.println("Sub1 error : "+err),
                ()->System.out.println("Sub1 Successful : "));

        range.filter(n->n%2!=0).subscribe(d->System.out.println("Sub2 Received : "+d),
                err->System.out.println("Sub2 error : "+err),
                ()->System.out.println("Sub2 Successful : "));

        Flux.range(1,10).filter(n->n<5).map(n->n*2).subscribe(System.out::println);

        Flux.range(1,10).map(n->Double.valueOf(n)).log().subscribe();

        Flux.range(1,10).map(n->Flux.just(Double.valueOf(n))).log().subscribe();

        Flux.range(1,10).flatMap(n->Flux.just(Double.valueOf(n))).log().subscribe();

        Flux.just(1,2,3).flatMap(n->{
            System.out.println("inside flatmap value ========");
            return Flux.range(n,n*2);
        }).log().subscribe();

    }
}
