package Mono_sample_operators;

import reactor.core.publisher.Mono;

import java.util.concurrent.Callable;
import java.util.concurrent.CompletableFuture;

public class MonoFrom {
    public static void main(String[] args) {

        //fromRunnable()
        Runnable runnable = ()->{
            System.out.println("I am in Runnable Impl");
        };
        Mono.fromRunnable(runnable).log().subscribe(System.out::println);

        //fromCallable()
        Callable callable = ()->{
            System.out.println("I am in Callable Impl");
            return 150;
        };
        Mono.fromCallable(callable).
                log().subscribe(System.out::println);

        //fromFuture()
        CompletableFuture comFut = CompletableFuture.supplyAsync(()->
        {System.out.println("I am in completable Future Impl");
                return 250;});
        Mono.fromFuture(comFut).
                log().subscribe(System.out::println);

        //fromSupplier()
        Mono.fromSupplier(()->{
            System.out.println("I am in supplier");
            return 350;
        }).log().subscribe(System.out::println);

    }
}
