package Flux_sample_operators;

import org.junit.jupiter.api.Test;
import reactor.core.publisher.Flux;

public class FluxCreateGeneratePush {

    @Test
    public void fluxCreate(){
        Flux.create(fluxSink -> {
            fluxSink.next("A");
            fluxSink.next("B");
            fluxSink.next("C");
            fluxSink.next("Peddi");
            //fluxSink.error(new Exception("This is my Exception"));
            fluxSink.complete();
        }).log().subscribe();
    }

    @Test
    public void fluxGenerate(){
        Flux.generate(()->97, (state, sink) -> {
            char value = (char) state.intValue();
            sink.next(value);
            if (value == 'e') {
                sink.complete();
            }
            return state + 1;
        }).log().subscribe();
    }

    @Test
    public void fluxPush(){
        Flux.push(fluxSink -> {
            fluxSink.next("A");
            fluxSink.next("B");
            fluxSink.next("C");
            fluxSink.next("Raju");
            //fluxSink.error(new Exception("This is my Error"));
            fluxSink.complete();
        }).log().subscribe(in->{System.out.println("Received----"+in);},
                throwable -> {
                    System.out.println("This is Exception-------"+throwable);
                });
    }
}
