package Mono_sample_operators;

import org.junit.jupiter.api.Test;
import reactor.core.publisher.Mono;

public class MonoEmptyJustError {

    @Test
    public void isEmptyAndNever(){
        //empty()
        Mono.empty().
                doOnEach(s->System.out.println(s.getType())).
                defaultIfEmpty("This is Empty Default Value").
                doOnNext(System.out::println).log().subscribe();
        //never()
        Mono.never().
                doOnEach(s -> System.out.println(s.getType())).
                defaultIfEmpty("This is Never Default Value").
                doOnNext(System.out::println).log().subscribe();
    }

    @Test
    public void monoJustCategory() {
        //just()
        Mono.just("John").
                log().subscribe(System.out::println);

        //justOrEmpty()
        Mono.justOrEmpty("Smith").log().subscribe(System.out::println);
    }

    @Test
    public void monoError() {
        //error()
        Mono.just("John Smith").concatWith(Mono.error(new RuntimeException())).
                doOnError(throwable -> System.out.println("This is Error block"+throwable)).
                log().subscribe(System.out::println);

        //Factory Error()
        Mono.error(new Exception("This is an Exception")).
                log().subscribe(System.out::println);
    }
}
