package Mono_sample_operators;

import org.junit.jupiter.api.Test;
import reactor.core.publisher.Mono;

import java.util.concurrent.Callable;
import java.util.concurrent.CompletableFuture;

public class MonoFrom {

    @Test
    public void monoRunnable(){
        //fromRunnable()
        Runnable runnable = ()->{
            System.out.println("I am in Runnable Impl");
        };
        Mono.fromRunnable(runnable).log().subscribe(System.out::println);
    }

    @Test
    public void monoCallable(){
        //fromCallable()
        Callable callable = ()->{
            System.out.println("I am in Callable Impl");
            return 150;
        };

        Mono.fromCallable(callable).
                log().subscribe(System.out::println);
    }

    @Test
    public void monoFuture(){
        //fromFuture()
        CompletableFuture comFut = CompletableFuture.supplyAsync(()->
        {System.out.println("I am in completable Future Impl");
            return 250;});
        Mono.fromFuture(comFut).
                log().subscribe(System.out::println);
    }

    @Test
    public void monoSupplier(){
        //fromSupplier()
        Mono.fromSupplier(()->{
            System.out.println("I am in supplier");
            return 350;
        }).log().subscribe(System.out::println);
    }
}
